#include <stdlib.h>

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

typedef struct noidle {
	float jump;
	float last;
	float next;
	float idle;
	struct noidle *head;
	struct noidle *tail;
	void (*funcptr) (void);
} idle;
struct noidle *here, *head, *tail;

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

float NOiD_iDLE_loop(float time)
{
	float wait;
	if ((head != NULL)&&(tail != NULL))
	{
		here = head;
		while (here != NULL)
		{
			if (here->next <= time)
			{
				if (here->funcptr != NULL)
				{
					here->funcptr();
					here->last = here->next;
					here->next = time + here->jump;
					here->idle = 0;
					here = tail;
					wait = 0;
				}
			} else {
				here->idle = here->next - time;
				if (here->idle <= wait)
				{	wait = here->idle;	}
			}
			here = here->tail;
		}
	}
	return wait;
}

//================================================================================================
//================================================================================================
//================================================================================================

idle * NOiD_iDLE_create(float interval,void (*function)(void))
{
	idle * this;
	if ((head == NULL)&&(tail == NULL))
	{
		this = malloc(sizeof(idle));
		this->head = NULL;
		this->tail = NULL;
		head = this;
		tail = this;
			this->jump = interval;
			this->funcptr = function;
	} else {
		if (head == tail)
		{
			this = malloc(sizeof(idle));
			tail = this;
			tail->head = head;
			tail->tail = NULL;
			head->head = NULL;
			head->tail = tail;
				this->jump = interval;
				this->funcptr = function;
		} else {
			if (tail->tail == NULL)
			{
				this = malloc(sizeof(idle));
				this->head = tail;
				this->tail = NULL;
				tail->tail = this;
				tail = this;
					this->jump = interval;
					this->funcptr = function;
			}
		}
	}
	return this;
}

//================================================================================================
//================================================================================================
//================================================================================================

void NOiD_iDLE_destroy(idle *this)
{
	if (this != NULL)
	{
		if (head == tail)
		{
			head = NULL;
			tail = NULL;
			free(this);
		} else {
			if (this->head == NULL)
			{
				this->head->tail = NULL;
				head = this->tail;
				free(this);
			} else {
				if (this->tail == NULL)
				{
					this->head->tail = NULL;
					tail = this->head;
					free(this);
				} else {
					this->head->tail = this->tail;
					this->tail->head = this->head;
					free(this);
				}
			}
		}
	}
}

//================================================================================================
//================================================================================================
//================================================================================================
